/* ctifpgalib.h - CTI FPGA Application Programming Interface */

/*
Copyright (c) 2011, CTI, Connect Tech Inc. All Rights Reserved.

THIS IS THE UNPUBLISHED PROPRIETARY SOURCE CODE OF CONNECT TECH INC.
The copyright notice above does not evidence any actual or intended
publication of such source code.

This module contains Proprietary Information of Connect Tech Inc
and should be treated as Confidential.
*/


#ifndef _ctifpgalib_H
#define _ctifpgalib_H
//#include "ioctls.h"

/**************************************************************************
 *  Error Status                                                          *
 **************************************************************************/
#define TRUE						1
#define FALSE						0
#define CTI_STATUS_OK             	0x0000
#define CTI_STATUS_ERROR           	0x0001
#define CTI_STATUS_INVALIDPARM   	0x0002
#define CTI_STATUS_TIMEOUT   		0x0003
#define CTI_STATUS_IOCTL_FAILED		0x0004
#define CTI_STATUS_INVALID_ARG1		0x10001
#define CTI_STATUS_INVALID_ARG2		0x10002
#define CTI_STATUS_INVALID_ARG3		0x10003
#define CTI_STATUS_INVALID_ARG4		0x10004
#define CTI_STATUS_INVALID_ARG5		0x10005

/**************************************************************************
 *  Structures
 **************************************************************************/
typedef struct _CtiUfpgaBoard
{
#ifdef WINDOWS_OS
	HANDLE hBoard; // handle to board for Windows
#else
	int fd; // file descriptor for non Windows
#endif
} CtiUfpgaBoard;

/**************************************************************************
 *  Functions
 **************************************************************************/
int CTIConnectBoard (CtiUfpgaBoard *pBoard,  unsigned char Index);
int CTIFindBoard (UFPGA_ALL_BOARDINFO *pAllBoardInfo);
int CTIDisconnectBoard (CtiUfpgaBoard *pBoard); 
int CTIGetBoardIndex(unsigned int VID, unsigned int DID, int instance, int* pIndex);

int CTIFPGARdByte(CtiUfpgaBoard *pBoard, int bar, int offset, unsigned char*);
int CTIFPGARdWord(CtiUfpgaBoard *pBoard, int bar, int offset, unsigned short*);
int CTIFPGARdDword(CtiUfpgaBoard *pBoard, int bar, int offset, unsigned int*);
int CTIFPGARdCfgDword(CtiUfpgaBoard *pBoard, int offset, unsigned int*);
int CTIFPGARdMem(CtiUfpgaBoard *pBoard, int bar, int offset, int szbytes, char *buffer);
int CTIFPGARdCfgMem(CtiUfpgaBoard *pBoard, int offset, int szbytes, char *buffer);
int CTIFPGARdFifo(CtiUfpgaBoard *pBoard, int bar, int offset, int szbytes, char *buffer);

int CTIFPGAWrByte(CtiUfpgaBoard *pBoard, int bar, int offset, unsigned char);
int CTIFPGAWrWord(CtiUfpgaBoard *pBoard, int bar, int offset, unsigned short);
int CTIFPGAWrDword(CtiUfpgaBoard *pBoard, int bar, int offset, unsigned int);
int CTIFPGAWrCfgDword(CtiUfpgaBoard *pBoard, int offset, unsigned int);
int CTIFPGAWrMem(CtiUfpgaBoard *pBoard, int bar, int offset, int szbytes, char *buffer);
int CTIFPGAWrCfgMem(CtiUfpgaBoard *pBoard, int offset, int szbytes, char *buffer);
int CTIFPGAWrFifo(CtiUfpgaBoard *pBoard, int bar, int offset, int szbytes, char *buffer);

#endif

